//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDirectDrawForm.h"
#include "winresrc.h"
#include "penwin.h"
//---------------------------------------------------------------------------
#pragma link "TDirectDraw"
#pragma link "Grids"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TDirectDrawForm *DirectDrawForm;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// remember: 	SetPriorityClass(hProcess: THandle; dwPriorityClass: DWORD): BOOL; stdcall;
//				USAGE: SetPriorityClass( GetCurrentProcess(), HIGH_PRIORITY_CLASS );
// remember:	Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TDirectDrawForm::TDirectDrawForm(TComponent* Owner)
	: TForm(Owner)
{
fAnimationTicks = 0;
fFramesFlipped = 0;
fSeconds = 0;
fColor = 0;
flast_time = Time();
fx = 0;
fy = 0;
fxincr = 1;
fyincr = 1;

fHandlingWMPAINT = false;

if (DirectDraw == NULL) DirectDraw = new TDirectDraw(this);
if (DirectDraw != NULL)
	{
    fIsGraphic = new bool[ControlCount];
    for (int i=0;i<ControlCount;i++) fIsGraphic[i] = IsGraphicControl( Controls[i] );
    }
}
//---------------------------------------------------------------------------
__fastcall 	TDirectDrawForm::~TDirectDrawForm()
{
if (DirectDraw != NULL)
	{
    delete[] fIsGraphic;
	if (DirectDraw->Owner == this)
		{
	    delete DirectDraw;
	    DirectDraw = NULL;
	    }
    }
}
//---------------------------------------------------------------------------
System::AnsiString	MessageStr( int message, int wparam, int lparam )
{
System::AnsiString msg;
switch (message)
	{
    case WM_PAINT:				msg = "WM_PAINT";				break;
    case WM_ERASEBKGND:			msg = "WM_ERASEBKGND";			break;
    case WM_DRAWITEM:			msg = "WM_DRAWITEM"; 			break;
    case WM_MEASUREITEM:		msg = "WM_MEASUREITEM";			break;
    case WM_VSCROLL:			msg = "WM_VSCROLL";				break;
    case WM_HSCROLL:    		msg = "WM_HSCROLL";				break;
	case WM_NCCALCSIZE:			msg = "WM_NCCALCSIZE";			break;
	case WM_COMMAND:			msg = "WM_COMMAND";				break;
	case WM_GETTEXT:			msg = "WM_GETTEXT";				break;
	case WM_GETTEXTLENGTH:      msg = "WM_GETTEXTLENGTH";		break;
	case WM_CTLCOLORMSGBOX:		msg = "WM_CTLCOLORMSGBOX";		break;
	case WM_CTLCOLOREDIT:		msg = "WM_CTLCOLOREDIT";		break;
	case WM_CTLCOLORLISTBOX:	msg = "WM_CTLCOLORLISTBOX";		break;
	case WM_CTLCOLORBTN:		msg = "WM_CTLCOLORBTN";			break;
	case WM_CTLCOLORDLG:		msg = "WM_CTLCOLORDLG";			break;
	case WM_CTLCOLORSCROLLBAR:	msg = "WM_CTLCOLORSCROLLBAR";	break;
	case WM_CTLCOLORSTATIC:		msg = "WM_CTLCOLORSTATIC";		break;
	case WM_NCHITTEST:			break;//msg = "WM_NCHITTEST";			break;
	case CM_CURSORCHANGED:		msg = "CM_CURSORCHANGED";		break;
	case CM_FONTCHANGED:		msg = "CM_FONTCHANGED";			break;
	case CN_DRAWITEM:			msg = "CN_DRAWITEM";			break;
	case WM_SETCURSOR:			break;//msg = "WM_SETCURSOR";			break;
	case WM_MOUSEFIRST:			msg = "WM_MOUSEFIRST";			break;
	case WM_NCMOUSEMOVE:		msg = "WM_NCMOUSEMOVE";			break;
	case WM_CAPTURECHANGED:		msg = "WM_CAPTURECHANGED";		break;
	case WM_MENUSELECT:			msg = "WM_MENUSELECT";			break;
	case WM_SYSCOMMAND:			msg = "WM_SYSCOMMAND";			break;
	case WM_NCLBUTTONDOWN:		msg = "WM_NCLBUTTONDOWN";		break;
	case WM_GETMINMAXINFO:		msg = "WM_GETMINMAXINFO";		break;
	case WM_MOVE:				msg = "WM_MOVE";				break;
	case WM_SIZE:				msg = "WM_SIZE";				break;
	case WM_WINDOWPOSCHANGING:	msg = "WM_WINDOWPOSCHANGING";	break;
	case WM_WINDOWPOSCHANGED:	msg = "WM_WINDOWPOSCHANGED";	break;
	case CN_CTLCOLORBTN:		msg = "CN_CTLCOLORBTN";			break;
	case CN_CTLCOLORDLG:		msg = "CN_CTLCOLORDLG";			break;
	case CN_CTLCOLOREDIT:		msg = "CN_CTLCOLOREDIT";		break;
	case CN_CTLCOLORLISTBOX:	msg = "CN_CTLCOLORLISTBOX";		break;
	case CN_CTLCOLORMSGBOX:		msg = "CN_CTLCOLORMSGBOX";		break;
	case CN_CTLCOLORSCROLLBAR:	msg = "CN_CTLCOLORSCROLLBAR";	break;
	case CN_CTLCOLORSTATIC:		msg = "CN_CTLCOLORSTATIC";		break;
	case CM_DIALOGKEY:			msg = "CM_DIALOGKEY";			break;
	case CM_DIALOGCHAR:			msg = "CM_DIALOGCHAR";			break;
	case CM_CHILDKEY:			msg = "CM_CHILDKEY";			break;
	case WM_SYSKEYUP:			msg = "WM_SYSKEYUP";			break;
	case WM_SYSKEYDOWN:			msg = "WM_SYSKEYDOWN";			break;
	case WM_PARENTNOTIFY:		msg = "WM_PARENTNOTIFY";		break;
	case WM_MOUSEACTIVATE:		msg = "WM_MOUSEACTIVATE";		break;
	case CM_FOCUSCHANGED:		msg = "CM_FOCUSCHANGED";		break;
	case WM_CTLCOLORMSGBOX-1:	msg = "WM_CTLCOLOR?";			break;
	case CM_PARENTSHOWHINTCHANGED:	msg = "CM_PARENTSHOWHINTCHANGED";	break;
	case WM_SETFOCUS:			msg = "WM_SETFOCUS";			break;
	case WM_KILLFOCUS:			msg = "WM_KILLFOCUS";			break;
	case CM_ICONCHANGED:		msg = "CM_ICONCHANGED";			break;
	case WM_KEYUP:				msg = "WM_KEYUP";				break;
	case CN_SYSKEYDOWN:			msg = "CN_SYSKEYDOWN";			break;
	case CN_NOTIFY:				msg = "CN_NOTIFY";				break;
	case CN_SYSCHAR:			msg = "CN_SYSCHAR";				break;
	case CN_KEYDOWN:			msg = "CN_KEYDOWN";				break;
	case CM_ENABLEDCHANGED:		msg = "CM_ENABLEDCHANGED";		break;
	case CM_CTL3DCHANGED:		msg = "CM_CTL3DCHANGED";		break;
	case WM_NCACTIVATE:         msg = "WM_NCACTIVATE";			break;
	case WM_NCPAINT:			msg = "WM_NCPAINT";				break;
    case WM_ENTERSIZEMOVE:		msg = "WM_ENTERSIZEMOVE";		break;
    case WM_SIZING:				msg = "WM_SIZING";				break;
    default:					msg = "UNKNOWN MESSAGE: " + IntToStr( message );
    }
return msg;
}
//---------------------------------------------------------------------------
void 	__fastcall TDirectDrawForm::WndProc(Messages::TMessage &Message)
{
bool use_directdraw = false;
if (DirectDraw != NULL)
   	use_directdraw = true;
if (!use_directdraw)
	{
    TForm::WndProc(Message);
    return;
    }

// handle any repaint messages coming from Windows rather than letting the default
// WndProc function handle them as the default WndProc function automatically draws
// the form when receiving WM_PAINT, WM_NCPAINT, WM_NCACTIVATE.....
// since the form redrawing code uses a windows gdi Paint3d function which blits to
// the display on completion (we have no control over this), it is probably better
// to use our own handler so that we can control exactly when to blit what.

int		message = Message.Msg;
int		lparam	= Message.LParam;
int		wparam	= Message.WParam;
int		sysmsg  = 0;
bool 	exclude_other_forms = false;

if (DirectDraw != NULL)
	{
    System::AnsiString msg = MessageStr( message, wparam, lparam );
    if (msg != "") DirectDraw->Log( LOG_NOTE, Name+"::WndProc", "Received message: "+msg );
    }

// pre-VCL message handling
switch (message)
	{
    case WM_ERASEBKGND:

       	{
        HDC hdc = (HDC) wparam;
 	    int SaveIndex = SaveDC( hdc );

        for (int i=0;i<ControlCount;i++)
        	if (fIsGraphic[i])
             	{
                TControl* control = Controls[i];
                if (control->Visible) ExcludeClipRect( hdc, control->Left,control->Top,control->Left+control->Width,control->Top+control->Height);
                }

        TForm::WndProc( Message );

        RestoreDC( hdc, SaveIndex );

        Message.Result = 1;
        }
		return;

   case WM_PAINT:

    	if (!fHandlingWMPAINT)
	    	{
	        fHandlingWMPAINT = true;

	        HDC hdc = (HDC) wparam;
		    int SaveIndex = SaveDC( hdc );

			fFramesFlipped++;

 			Messages::TWMPaint	MyPaintMessage;
			MyPaintMessage.Msg = WM_PAINT;
			MyPaintMessage.DC  = hdc;
			MyPaintMessage.Unused = 0;
			MyPaintMessage.Result = 0;
			PaintHandler( MyPaintMessage );

	        fHandlingWMPAINT = false;

            // let windows know that we've handled the WM_PAINT message
			ValidateRect( Handle, NULL );
	        Message.Msg = 0;

	        return;
	        }
	    break;
    }

// let the VCL handle the message
TForm::WndProc(Message);
}
//---------------------------------------------------------------------------
bool	__fastcall	TDirectDrawForm::IsGraphicControl( TControl* control )
{
TClass	theclass = control->ClassType();
bool	isGraphicControl = false;
while	(theclass != NULL)
	{
	System::AnsiString	class_name = theclass->ClassName();
	if (class_name == "TGraphicControl")
		{
		isGraphicControl = true;
	    break;
		}
    theclass = theclass->ClassParent();
	}
return isGraphicControl;
}
//---------------------------------------------------------------------------
void __fastcall	TDirectDrawForm::ExcludeOtherControls( HDC hdc, int control_being_painted )
{
for (int i=ControlCount-1;i>=0;i--)
	{
    bool isGraphicControl = fIsGraphic[i];
	if (!isGraphicControl || ((i>control_being_painted) && isGraphicControl) )
    	{
		bool control_is_visible = Controls[i]->Visible;
		if (control_is_visible)
			{
			int xleft = Controls[i]->Left;
            int xtop = Controls[i]->Top;
			int xright = xleft + Controls[i]->Width;
			int xbottom = xtop + Controls[i]->Height;
			ExcludeClipRect( hdc, xleft, xtop, xright, xbottom );
        	}
        }
	}
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::PaintHandler(Messages::TWMPaint &Message)
{
bool use_directdraw = false;
if (DirectDraw != NULL)
   	use_directdraw = true;
if (!use_directdraw)
	{
    TForm::PaintHandler(Message);
    return;
    }
if (WindowState == wsMinimized) return;

// if the supplied DC is okay, use it, otherwise try getting one from DirectDraw
HDC hdc;
PAINTSTRUCT ps;
if (Message.DC != 0) hdc = Message.DC;
else	hdc = BeginPaint( Handle, &ps );

// use standard function calls to paint to our DirectX surface
try
  	{
    int	SaveIndex;
    int Clip;

    if (ControlCount==0)
    	{
        PaintWindow(hdc);
        }
    else
    	{
        SaveIndex = SaveDC( hdc );
	    Clip = SIMPLEREGION;
        for (int i=0;i<ControlCount;i++)
			{
		   	if (Controls[i]->Visible)
				{
		        int xleft = Controls[i]->Left;
		        int xtop = Controls[i]->Top;
		        int xright = xleft + Controls[i]->Width;
		        int xbottom = xtop + Controls[i]->Height;

                Clip = ExcludeClipRect( hdc, xleft, xtop, xright, xbottom );
	            if (Clip == NULLREGION) break;
	            }
            }
        if (Clip != NULLREGION) PaintWindow( hdc );
	    RestoreDC( hdc, SaveIndex );
        }
    PaintControls( hdc, NULL );
	}
// unless a problem occurs
catch (...) {}

if (Message.DC == 0) EndPaint( Handle, &ps );

//DirectDraw->DrawMouseCursor( hdc );
}
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawForm::PaintWindow(HDC hdc)
{
Canvas->Handle = hdc;
try
	{
    Paint();
    }
catch ( ... ) {}
Canvas->Handle = NULL;
}
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawForm::PaintControls(HDC hdc, TControl* First)
{
bool use_directdraw = false;
if (DirectDraw != NULL)
   	use_directdraw = true;
if (!use_directdraw)
	{
    TForm::PaintControls(hdc, First);
    return;
    }
if (ControlCount==0) return;
if (hdc == NULL) return;

int controls_to_be_painted = ControlCount;
int control_being_painted = 0;	// first control to paint
if (First != NULL)
	{
    for (int control=0;control<ControlCount;control++)
		if (Controls[control] == First)
        	{
            control_being_painted = control;
            break;
            }
    }

// scan though all controls and paint them each in turn (starting at "control_being_painted")
for (int loop=0;loop<controls_to_be_painted;loop++)
	{
    TControl* control = Controls[control_being_painted];

	// if the control in question is a "graphic control" and it's currently visible
	if (fIsGraphic[control_being_painted] && Controls[control_being_painted]->Visible)
    	{
	    int SaveIndex = SaveDC( hdc );

        // make sure to not paint over any other graphic controls that have
        ExcludeOtherControls( hdc, control_being_painted );

		// figure out the relative rect of the control
		RECT r;
        r.left = control->Left;
        r.top = control->Top;
        r.right = r.left + control->Width;
		r.bottom = r.top + control->Height;

        // if any portion of the control is visible, paint the control
		if (RectVisible( hdc, &r ))
           	{
		 	MoveWindowOrg( hdc, r.left, r.top );
		    control->Perform(WM_PAINT, (long) hdc, 0);
			MoveWindowOrg( hdc, -r.left, -r.top );
            }

		// restore the DC's original settings (mostly the default clip region)
	    RestoreDC( hdc, SaveIndex );
        }

    ++control_being_painted %= ControlCount;	// wrap to 0..ControlCount-1
    }
}







//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::ResetCountersButtonClick(TObject *Sender)
{
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::ExitButtonClick(TObject *Sender)
{
if (Enabled) Close();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::UpdateDirectXMessages()
{
if (DirectDraw != NULL)
	{
	if (DirectDraw->ErrorStrings)
		{
		DebugMessages->Items->Clear();
		for (int i=0;i<DirectDraw->ErrorStrings->Count;i++)
			DebugMessages->Items->Add(DirectDraw->ErrorStrings->Strings[i]);
        DebugMessages->Repaint();
	    }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::FormDeactivate(TObject *Sender)
{
DebugMessages->Items->Clear();
}
//---------------------------------------------------------------------------
int TimesIn = 0;
void __fastcall TDirectDrawForm::FormPaint(TObject *Sender)
{
// --------- debugging formpaint() code

// display the number of frames, etc. being drawn
TDateTime current_time = Time();
unsigned short chour,cmin,csec,cmsec;
unsigned short lhour,lmin,lsec,lmsec;
current_time.DecodeTime(&chour,&cmin,&csec,&cmsec);
flast_time.DecodeTime(&lhour,&lmin,&lsec,&lmsec);
int seconds_elapsed = 0;
if (csec != lsec)
	{
    if (csec < lsec) seconds_elapsed += 60;
    seconds_elapsed += (csec - lsec);
    }
fSeconds += seconds_elapsed;
flast_time = current_time;

TicksLabel->Caption = "Ticks: " + IntToStr(fAnimationTicks);
FramesLabel->Caption = "Frames: " + IntToStr(fFramesFlipped);
SecondsLabel->Caption = "Seconds: " + IntToStr(fSeconds);
if (fSeconds != 0)
	{
    FramesPerSecondLabel->Caption = "FPS: " + FloatToStrF((float)fFramesFlipped / (float)fSeconds, ffFixed, 6, 2);
	}
AnimSpeedLabel->Caption = "Anim: " + IntToStr(Timer1->Interval);

// also display some DirectX stats, etc.
if (DirectDraw != NULL)
	{
    DirectXInstalledLabel->Font->Color = clGreen;
    DirectXInstalledLabel->Caption = "DirectX is Installed";

	if (DirectDraw->Debugging)
		{
	    DirectXDebuggingLabel->Font->Color = clGreen;
	    DirectXDebuggingLabel->Caption = "DirectX debugging is enabled";
	    }
	else
		{
	    DirectXDebuggingLabel->Font->Color = clRed;
	    DirectXDebuggingLabel->Caption = "DirectX debugging is not enabled";
	    }
    }
else
	{
    DirectXInstalledLabel->Font->Color = clRed;
    DirectXInstalledLabel->Caption = "DirectX is Not Installed";
    }

//================================================================================
// normal FormPaint() code
TimesIn++;

for (int z=0; z<1000; z++)
   	Canvas->Pixels[random(Width)][random(Height)] = (TColor) ((z << 16) + (z << 8) + z);
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::RepaintMessagesButtonClick(TObject *Sender)
{
// make sure the scroll box of directx messages is realtime.....
UpdateDirectXMessages();
if (DebugMessages->Showing && (ActiveControl == DebugMessages))
	{
    DebugMessages->Hide();
    DebugMessages->Show();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::ClearMessagesButtonClick(TObject *Sender)
{
if (Enabled && (DirectDraw != NULL))
	{
    DirectDraw->ErrorStrings->Clear();
	Refresh();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::ToggleDebuggingButtonClick(TObject *Sender)
{
if (Enabled && (DirectDraw != NULL))
	{
    DirectDraw->Debugging = !DirectDraw->Debugging;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::BitBtn2Click(TObject *Sender)
{
if (Timer1->Interval>1000) Timer1->Interval -= 1000;
else if (Timer1->Interval>100) Timer1->Interval -= 100;
else if (Timer1->Interval>10) Timer1->Interval -= 10;
else if (Timer1->Interval>1) Timer1->Interval -= 1;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::BitBtn4Click(TObject *Sender)
{
if (Timer1->Interval<10) Timer1->Interval += 1;
else if (Timer1->Interval<100) Timer1->Interval += 10;
else if (Timer1->Interval<1000) Timer1->Interval += 100;
else if (Timer1->Interval<10000) Timer1->Interval += 1000;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button1Click(TObject *Sender)
{
Timer1Timer( Sender );
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button2Click(TObject *Sender)
{
Timer1->Enabled = !Timer1->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::ScrollBar1Scroll(TObject *Sender, TScrollCode ScrollCode, int &ScrollPos)
{
Timer1->Interval = ScrollPos * 10;
}
//---------------------------------------------------------------------------
int fXIncr = 1;
int fYIncr = 0;
void __fastcall TDirectDrawForm::Timer1Timer(TObject *Sender)
{
// perform a really simple animation
Image1->Left += fXIncr;
Image1->Top += fYIncr;

if (Image1->Left<0)
	{
    Image1->Left++;
    fXIncr = 0;
    fYIncr = -1;
    }
if (Image1->Top<0)
	{
    Image1->Top++;
    fXIncr = 1;
    fYIncr = 0;
    }
if (Image1->Left+Image1->Width > Width)
	{
    Image1->Left--;
    fXIncr = 0;
    fYIncr = 1;
    }
if (Image1->Top+Image1->Height > Height)
	{
    Image1->Top--;
    fXIncr = -1;
    fYIncr = 0;
    }

// do something else as well
Image2->Left -= fXIncr * 4;
Image2->Top -= fYIncr * 4;

// because it's the TDirectDraw form (actual)
Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button6Click(TObject *Sender)
{
DirectDraw->SetDisplayMode(640,480,8);
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button7Click(TObject *Sender)
{
DirectDraw->SetDisplayMode(800,600,16);
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button8Click(TObject *Sender)
{
DirectDraw->SetDisplayMode(1024,768,16);
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button3Click(TObject *Sender)
{
Timer1->Interval = 1;	
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::Button4Click(TObject *Sender)
{
Timer1->Interval = 1000;	
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawForm::FormCreate(TObject *Sender)
{
if (DirectDraw == NULL)
	{
	ShowMessage( "Could not create DirectDraw object, aborting execution" );
    Close();
    }
else
	{
    Top = 0;
    Left = 0;
    Width = 200;
    Height = Screen->Height;
    }
}
//---------------------------------------------------------------------------
