//---------------------------------------------------------------------------
//
//	TDirectDrawForm - VCL & DirectX transparent implementation
//
//	(c) 1997 Darren J. Dwyer  - All Rights Reserved
//
// Disclaimer:
// All source code, object files, documentation files, etc. included
// with this package are copyright. Any use contrary to the attached
// file LICENCE.DOC are deemed to be breaches of copyright.
//
//---------------------------------------------------------------------------
#ifndef TDirectDrawFormH
#define TDirectDrawFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include "Grids.hpp"
//---------------------------------------------------------------------------
#include "TDirectDraw.h"
#include <vcl\MPlayer.hpp>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
#define	dmNormal		0
#define	dmPrimary       1
#define	dmBackBuffer	2
//---------------------------------------------------------------------------
class TDirectDrawForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *TimingPanel;
	TLabel *FramesLabel;
	TLabel *SecondsLabel;
	TLabel *FramesPerSecondLabel;
	TPanel *InformationPanel;
	TListBox *DebugMessages;
	TBitBtn *ResetCountersButton;
	TButton *ExitButton;
	TShape *Shape1;
	TBitBtn *RepaintMessagesButton;
	TBitBtn *ClearMessagesButton;
	TBitBtn *ToggleDebuggingButton;
	TLabel *AnimSpeedLabel;
	TLabel *TicksLabel;
	TLabel *DirectXInstalledLabel;
	TLabel *DirectXDebuggingLabel;
	TLabel *DirectXEnabledLabel;
	TImage *Image1;
	TBitBtn *BitBtn2;
	TBitBtn *BitBtn4;
	TRadioGroup *RadioGroup1;
	TMemo *Memo1;
	TEdit *Edit1;
	TScrollBar *ScrollBar1;
	TButton *Button1;
	TButton *Button2;
	TListBox *ListBox1;
	TSpeedButton *SpeedButton1;
	TTimer *Timer1;
	TLabel *Label1;
	TButton *Button6;
	TButton *Button7;
	TButton *Button8;
	TButton *Button3;
	TButton *Button4;
	TImage *Image2;
	TShape *Shape2;
	void __fastcall ResetCountersButtonClick(TObject *Sender);
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
	void __fastcall RepaintMessagesButtonClick(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall ToggleDebuggingButtonClick(TObject *Sender);
	void __fastcall ClearMessagesButtonClick(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall BitBtn4Click(TObject *Sender);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall ScrollBar1Scroll(TObject *Sender, TScrollCode ScrollCode, int &ScrollPos);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall Button6Click(TObject *Sender);
	void __fastcall Button7Click(TObject *Sender);
	void __fastcall Button8Click(TObject *Sender);
	void __fastcall Button3Click(TObject *Sender);
	void __fastcall Button4Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	
private:	// User declarations

	// BEGIN 			DirectXForm stuff
    bool				fHandlingWMPAINT;
    bool*				fIsGraphic;
	// END 				DirectXForm stuff

	// other drawing stuff
	unsigned int		fAnimationTicks;
	unsigned int		fFramesFlipped;
    unsigned int		fSeconds;
    unsigned int		fColor;
    TDateTime 			flast_time;
	int 				fx;
	int 				fy;
	int 				fxincr;
	int 				fyincr;

protected:

		// BEGIN 	overloaded VCL functions used to draw the form / controls
		void 		__fastcall	WndProc(Messages::TMessage &Message);
        bool		__fastcall	IsGraphicControl( TControl* control );
        void 		__fastcall	ExcludeOtherControls( HDC hdc, int control_being_painted );
		void 		__fastcall	PaintHandler(Messages::TWMPaint &Message);
		void 		__fastcall 	PaintWindow(HDC hdc);
		void		__fastcall	PaintControls(HDC hdc, TControl* First);

public:		// User declarations
				__fastcall 	TDirectDrawForm(TComponent* Owner);
	virtual		__fastcall 	~TDirectDrawForm();
    void		__fastcall	UpdateDirectXMessages();
};
//---------------------------------------------------------------------------
extern TDirectDrawForm *DirectDrawForm;
//---------------------------------------------------------------------------
#endif


